"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.mapDispatchToProps = void 0;

var _reactRedux = require("react-redux");

var _Toggle = _interopRequireDefault(require("@bootstrap-styled/toggle/lib/components/Toggle"));

var _reselect = require("reselect");

var _selectors = require("@bootstrap-styled/redux/lib/selectors");

var _selectors2 = require("../selectors");

var _actions = require("../actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = (0, _reselect.createStructuredSelector)({
  value: _selectors.selectValue,
  values: _selectors2.selectAsyncValues
});

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    onToggle: function onToggle(evt) {
      return dispatch((0, _actions.changeThemeRequest)(evt.target.value));
    }
  };
};
/**
 * AsyncThemeToggle is used to display a select option to change async theme
 * @constructor
 */


exports.mapDispatchToProps = mapDispatchToProps;

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_Toggle.default);

exports.default = _default;