"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.mergeProps = exports.mapDispatchToProps = void 0;

var _reactRedux = require("react-redux");

var _Toggle = _interopRequireDefault(require("@bootstrap-styled/toggle/lib/components/Toggle"));

var _reselect = require("reselect");

var _actions = require("@bootstrap-styled/redux/lib/actions");

var _selectors = require("@bootstrap-styled/redux/lib/immutable/selectors");

var _selectors2 = require("../selectors");

var _actions2 = require("../../actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var mapStateToProps = (0, _reselect.createStructuredSelector)({
  /** we pick the actual value from bootstrap-styled-redux */
  value: _selectors.selectValue,

  /** we use a special selector that group values of both store */
  values: _selectors2.selectGroupedValues,

  /** we need to map the async themes here otherwise we cannot filter and know which key come from the async store. */
  asyncThemes: _selectors2.selectAsyncThemes
});

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    dispatch: dispatch
  };
};
/* eslint-disable no-underscore-dangle, no-plusplus, no-cond-assign */


exports.mapDispatchToProps = mapDispatchToProps;

var mergeProps = function mergeProps(_ref, _ref2) {
  var asyncThemes = _ref.asyncThemes,
      stateProps = _objectWithoutProperties(_ref, ["asyncThemes"]);

  var dispatch = _ref2.dispatch,
      dispatchProps = _objectWithoutProperties(_ref2, ["dispatch"]);

  return _objectSpread({}, stateProps, dispatchProps, {
    onToggle: function onToggle(evt) {
      var asyncKey = false;
      var key;
      var keys = Object.keys(asyncThemes);

      while (key = keys.shift()) {
        if (key === evt.target.value) {
          asyncKey = true;
          break;
        }
      }

      return dispatch(asyncKey ? (0, _actions2.changeThemeRequest)(evt.target.value) : (0, _actions.changeTheme)(evt.target.value));
    }
  });
};
/**
 * AllThemeToggle will display sync and unsync theme
 * @constructor
 */


exports.mergeProps = mergeProps;

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps)(_Toggle.default);

exports.default = _default;