"use strict";

var _react = _interopRequireDefault(require("react"));

var _immutable = require("immutable");

var _reactRedux = require("react-redux");

var _enzyme = require("enzyme");

var _reduxImmutable = require("redux-immutable");

var _redux = require("redux");

var _reducer = _interopRequireDefault(require("@bootstrap-styled/redux/lib/immutable/reducer"));

var _theme = _interopRequireWildcard(require("bootstrap-styled/lib/theme"));

var _actions = require("@bootstrap-styled/redux/lib/actions");

var _reducer2 = _interopRequireDefault(require("../../reducer"));

var _actions2 = require("../../../actions");

var _index = _interopRequireWildcard(require("../index"));

var _themeProvider = require("../../../../styleguide/components/tests/themeProvider");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable function-paren-newline, no-underscore-dangle */
describe('<AsyncThemeToggle />', function () {
  var store;
  var reducer;
  beforeAll(function () {
    reducer = (0, _reduxImmutable.combineReducers)({
      'bs.redux': _reducer.default,
      'bs.saga': _reducer2.default
    });
    store = (0, _redux.createStore)(reducer, (0, _immutable.fromJS)({
      'bs.redux': {
        theme: _theme.default,
        themes: _defineProperty({}, "".concat(_theme.default._name, "-pink-async"), (0, _theme.makeTheme)({
          _name: "".concat(_theme.default._name, "-pink-async"),
          '$btn-primary-bg': 'pink'
        }))
      },
      'bs.saga': {
        themes: _themeProvider.themes
      }
    }));
  });
  it('should render the default language messages', function () {
    var renderedComponent = (0, _enzyme.mount)(_react.default.createElement(_reactRedux.Provider, {
      store: store
    }, _react.default.createElement(_index.default, null)));
    expect(renderedComponent.contains(_react.default.createElement(_index.default, null))).toBe(true);
  });
  describe('mapDispatchToProps', function () {
    describe('dispatch', function () {
      var dispatchProps;
      var dispatch;
      it('should be injected', function () {
        dispatch = jest.fn();
        dispatchProps = (0, _index.mapDispatchToProps)(dispatch);
        expect(dispatchProps.dispatch).toBeDefined();
      });
      describe('mergeProps', function () {
        var stateProps;
        var mergedProps;
        beforeAll(function () {
          dispatch = jest.fn();
          stateProps = {
            asyncThemes: _themeProvider.themes
          };
        });
        it('should dispatch onToggle async when called', function () {
          dispatch = jest.fn();
          dispatchProps = (0, _index.mapDispatchToProps)(dispatch);
          mergedProps = (0, _index.mergeProps)(stateProps, dispatchProps);
          var evt = {
            target: {
              value: Object.keys(_themeProvider.themes)[0]
            }
          };
          mergedProps.onToggle(evt);
          expect(dispatch).toHaveBeenCalledWith((0, _actions2.changeThemeRequest)(Object.keys(_themeProvider.themes)[0]));
        });
        it('should dispatch onToggle sync when called', function () {
          dispatch = jest.fn();

          var newTheme = _objectSpread({}, _theme.default, {
            _name: 'edited',
            _async: true
          });

          dispatchProps = (0, _index.mapDispatchToProps)(dispatch);
          mergedProps = (0, _index.mergeProps)(stateProps, dispatchProps);
          var evt = {
            target: {
              value: newTheme._name
            }
          };
          mergedProps.onToggle(evt);
          expect(dispatch).toHaveBeenCalledWith((0, _actions.changeTheme)(newTheme._name));
        });
      });
    });
  });
});