"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = asyncThemeReducer;
exports.initialState = void 0;

var _immutable = require("immutable");

var _constants = require("../../constants");

var initialState = (0, _immutable.fromJS)({
  themes: {}
});
/* eslint-disable no-underscore-dangle */

/**
 * asyncThemeReducer
 * @param state
 * @param action
 * @returns {*}
 */

exports.initialState = initialState;

function asyncThemeReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case _constants.STORE_ASYNC_THEME:
      {
        return state.setIn(['themes', action.theme._name], (0, _immutable.fromJS)(action.theme));
      }

    case _constants.DELETE_ASYNC_THEMES:
      {
        return state.set('themes', (0, _immutable.fromJS)({}));
      }

    default:
      return state;
  }
}