"use strict";

var _immutable = require("immutable");

var _index = _interopRequireWildcard(require("../index"));

var _actions = require("../../../actions");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

describe('asyncThemeReducer immutable', function () {
  var state;
  var expectedResult;
  beforeEach(function () {
    state = _index.initialState;
    expectedResult = undefined;
  });
  it('should return the initial state', function () {
    expectedResult = state;
    expect((0, _index.default)(undefined, {})).toEqual(expectedResult);
  });
  it('should handle the deleteAsyncThemes action correctly', function () {
    expectedResult = (0, _immutable.fromJS)({
      themes: {}
    });
    expect((0, _index.default)(state, (0, _actions.deleteAsyncThemes)())).toEqual(expectedResult);
  });
  it('should handle the storeAsyncTheme action correctly', function () {
    var theme = {
      _name: 'test',
      $white: '#eee'
    };
    expectedResult = (0, _immutable.fromJS)({
      themes: _defineProperty({}, theme._name, theme)
    });
    expect((0, _index.default)(state, (0, _actions.storeAsyncTheme)(theme))).toEqual(expectedResult);
  });
});