"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.selectGroupedValues = exports.selectGroupedThemes = exports.selectAsyncValues = exports.selectAsyncThemes = exports.selectBsSaga = void 0;

var _reselect = require("reselect");

var selectBsSaga = function selectBsSaga(state) {
  return state.get('bs.saga');
};
/**
 * themes
 */


exports.selectBsSaga = selectBsSaga;
var selectAsyncThemes = (0, _reselect.createSelector)(selectBsSaga, function (bsSagaState) {
  return bsSagaState.get('themes');
});
/**
 * async theme values
 */

exports.selectAsyncThemes = selectAsyncThemes;
var selectAsyncValues = (0, _reselect.createSelector)(selectBsSaga, function (bsSagaState) {
  return bsSagaState.get('themes').keySeq().toArray();
});
/**
 * async all themes
 */

exports.selectAsyncValues = selectAsyncValues;

var selectGroupedThemes = function selectGroupedThemes(state) {
  return state.getIn(['bs.saga', 'themes']).mergeDeep(state.getIn(['bs.redux', 'themes']));
};
/**
 * async all theme values
 */


exports.selectGroupedThemes = selectGroupedThemes;
var selectGroupedValues = (0, _reselect.createSelector)(selectGroupedThemes, function (groupedThemes) {
  return groupedThemes.keySeq().toArray();
});
exports.selectGroupedValues = selectGroupedValues;