"use strict";

var _immutable = require("immutable");

var _theme = _interopRequireDefault(require("bootstrap-styled/lib/theme"));

var _reducer = require("../reducer");

var _selectors = require("../selectors");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

describe('selectBsSaga immutable', function () {
  var state;
  var bsSagaState;
  beforeEach(function () {
    bsSagaState = _reducer.initialState;
    state = (0, _immutable.fromJS)({
      'bs.saga': bsSagaState
    });
  });
  describe('selectBsSaga', function () {
    it('should select the bootstrap-styled-saga state', function () {
      expect((0, _selectors.selectBsSaga)(state)).toEqual(state.get('bs.saga'));
    });
    describe('selectAsyncThemes', function () {
      it('should select the async themes', function () {
        expect((0, _selectors.selectAsyncThemes)(state)).toEqual(bsSagaState.get('themes'));
      });
    });
    describe('selectAsyncValues', function () {
      it('should select the async themes values', function () {
        expect((0, _selectors.selectAsyncValues)(state)).toEqual(bsSagaState.get('themes').keySeq().toArray());
      });
    });
  });
  describe('selectBsRedux and selectBsSaga', function () {
    it('should select sync and async themes', function () {
      expect((0, _selectors.selectBsSaga)(state)).toEqual(state.get('bs.saga'));
    });
    describe('selectGroupedThemes', function () {
      var doubleState = (0, _immutable.fromJS)({
        'bs.redux': {
          theme: _theme.default,
          themes: _defineProperty({}, _theme.default._name, _theme.default)
        },
        'bs.saga': {
          themes: {
            copy: _theme.default
          }
        }
      });
      it('should select the async themes', function () {
        var _fromJS;

        expect((0, _selectors.selectGroupedThemes)(doubleState)).toEqual((0, _immutable.fromJS)((_fromJS = {}, _defineProperty(_fromJS, _theme.default._name, _theme.default), _defineProperty(_fromJS, "copy", _theme.default), _fromJS)));
      });
    });
    describe('selectGroupedValues', function () {
      var doubleState = (0, _immutable.fromJS)({
        'bs.redux': {
          theme: _theme.default,
          themes: _defineProperty({}, _theme.default._name, _theme.default)
        },
        'bs.saga': {
          themes: {
            copy: _theme.default
          }
        }
      });
      it('should select the grouped values', function () {
        expect((0, _selectors.selectGroupedValues)(doubleState)).toEqual(['copy', new String(_theme.default._name)]); // eslint-disable-line no-underscore-dangle, no-new-wrappers
      });
    });
  });
});