"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.selectGroupedValues = exports.selectGroupedThemes = exports.selectAsyncValues = exports.selectAsyncThemes = exports.selectBsSaga = void 0;

var _reselect = require("reselect");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var selectBsSaga = function selectBsSaga(state) {
  return state['bs.saga'];
};
/**
 * themes
 */


exports.selectBsSaga = selectBsSaga;
var selectAsyncThemes = (0, _reselect.createSelector)(selectBsSaga, function (bsSagaState) {
  return bsSagaState.themes;
});
/**
 * async theme values
 */

exports.selectAsyncThemes = selectAsyncThemes;
var selectAsyncValues = (0, _reselect.createSelector)(selectBsSaga, function (bsSagaState) {
  return Object.keys(bsSagaState.themes);
});
/**
 * async all themes
 */

exports.selectAsyncValues = selectAsyncValues;
var selectGroupedThemes = (0, _reselect.createSelector)(function (state) {
  return {
    sagaState: state['bs.saga'],
    reduxState: state['bs.redux']
  };
}, function (tmpState) {
  return _objectSpread({}, tmpState.reduxState.themes, tmpState.sagaState.themes);
});
/**
 * async all theme values
 */

exports.selectGroupedThemes = selectGroupedThemes;
var selectGroupedValues = (0, _reselect.createSelector)(function (state) {
  return {
    sagaState: state['bs.saga'],
    reduxState: state['bs.redux']
  };
}, function (tmpState) {
  return Object.keys(tmpState.sagaState.themes).concat(Object.keys(tmpState.reduxState.themes));
});
exports.selectGroupedValues = selectGroupedValues;