"use strict";

var _effects = require("redux-saga/effects");

var _bootstrapStyled = require("bootstrap-styled");

var _actions = require("@bootstrap-styled/redux/lib/actions");

var _constants = require("../constants");

var _actions2 = require("../actions");

var _saga = _interopRequireWildcard(require("../saga"));

var _themeProvider = _interopRequireWildcard(require("../../styleguide/components/tests/themeProvider"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable redux-saga/yield-effects */
describe('bootstrapSaga Saga', function () {
  var bootstrapSaga;
  it('should start task to watch for CHANGE_THEME_REQUEST action using keys as themes', function () {
    bootstrapSaga = (0, _saga.default)(_themeProvider.default, Object.keys(_themeProvider.themes))();
    var takeLatestDescriptor = bootstrapSaga.next().value;
    expect(JSON.stringify(takeLatestDescriptor)).toEqual(JSON.stringify((0, _effects.all)([(0, _effects.takeLatest)(_constants.CHANGE_THEME_REQUEST, (0, _saga.makeLoadTheme)(_themeProvider.default))].concat(Object.keys(_themeProvider.themes).map(function (key) {
      return (0, _effects.put)((0, _actions2.storeAsyncTheme)({
        _name: key,
        _async: true,
        _loaded: false
      }));
    })))));
  });
  it('should start task to watch for CHANGE_THEME_REQUEST action using themes object', function () {
    bootstrapSaga = (0, _saga.default)(_themeProvider.default, _themeProvider.themes)();
    var takeLatestDescriptor = bootstrapSaga.next().value;
    expect(JSON.stringify(takeLatestDescriptor)).toEqual(JSON.stringify((0, _effects.all)([(0, _effects.takeLatest)(_constants.CHANGE_THEME_REQUEST, (0, _saga.makeLoadTheme)(_themeProvider.default))].concat(Object.keys(_themeProvider.themes).map(function (key) {
      return (0, _effects.put)((0, _actions2.storeAsyncTheme)({
        _name: key,
        _async: true,
        _loaded: false
      }));
    })))));
  });
});
describe('makeLoadTheme Saga', function () {
  var loadThemeGenerator;
  var name; // We have to test twice, once for a successful load and once for an unsuccessful one
  // so we do all the stuff that HAPPENS beforehand automatically in the beforeEach

  beforeEach(function () {
    name = _bootstrapStyled.theme._name; // eslint-disable-line no-underscore-dangle

    loadThemeGenerator = (0, _saga.makeLoadTheme)(_themeProvider.default)({
      name: name
    });
    var descriptor = loadThemeGenerator.next().value;
    expect(descriptor).toEqual((0, _effects.call)(_themeProvider.default, name));
  });
  it('should dispatch the changeTheme action if it requests the data successfully', function () {
    var putDescriptor = loadThemeGenerator.next(_bootstrapStyled.theme).value;
    expect(putDescriptor).toEqual((0, _effects.put)((0, _actions.changeTheme)(_objectSpread({}, _bootstrapStyled.theme, {
      _async: true,
      _loaded: true
    }))));
  });
  it('should call the changeThemeFailure action if the response errors', function () {
    var response = new Error('Some error');
    var putDescriptor = loadThemeGenerator.throw(response).value;
    expect(putDescriptor).toEqual((0, _effects.put)((0, _actions2.changeThemeFailure)(name, response)));
  });
});